class Ball { // Missende hoofdletter
    constructor(index) {
        // Gebruik geen variabel namen van één karakter
        this.index = index;
        this.radius = random(20, 50);
        this.xPos = random(this.radius / 2, width - this.radius / 2);
        this.yPos = random(this.radius / 2, height - this.radius / 2);
        this.xSpeed = random(-10, 10);
        this.ySpeed = random(-10, 10);

        this.mColor = color(random(0, 255), random(0, 255), random(0, 255));
    }

    /**
     * Draw the component
     */
    draw() {
        fill(this.mColor);
        ellipse(this.xPos, this.yPos, this.radius);
    }

    /**
     * Move around the screen, hit on walls
     */
    move() {
        this.xPos += this.xSpeed;
        this.yPos += this.ySpeed; // Verkeerde variabele

        if (this.xPos < this.radius / 2) {
            this.xPos = this.radius / 2;
            this.xSpeed *= -1;
            this.hitWall(3);
        } else if (this.xPos > width - this.radius / 2) {
            this.xPos = width - this.radius / 2;
            this.xSpeed *= -1; // Typo
            this.hitWall(1);
        } else if (this.yPos < this.radius / 2) {
            this.yPos = this.radius / 2;
            this.ySpeed *= -1;
            this.hitWall(0);
        } else if (this.yPos > height - this.radius / 2) {
            this.yPos = height - this.radius / 2;
            this.ySpeed *= -1;
            this.hitWall(2);
        }
    }

    /**
     * Handle onMousePressed per ball
     * Change color of ball on click
     */
    mousePressed() {
        // Beter om op te splitsen in meerdere regels
        let insideXBounds = (mouseX >= this.xPos - this.radius / 2) && (mouseX <= this.xPos + this.radius / 2)
        let insideYBounds = (mouseY >= this.yPos - this.radius / 2) && (mouseY <= this.yPos + this.radius / 2)
        if (insideXBounds && insideYBounds) {
            this.mColor = color(random(0, 255), random(0, 255), random(0, 255));
        }
    }

    /**
     * Handle screen resizes
     */
    resize() {}

    /**
     * Function executed when a wall is hit
     * @param {number} wallNumber number of wall counting clockwise with top = 0
     */
    hitWall(wallNumber) {
        if (client) client.sendMessage("/ball/hit", this.index, wallNumber); // Check of client is ingesteld, anders doet hij het niet. this.index bestaat niet, moet this.i zijn
    }
}